/* ODE tutorial  by Kosei Demura     */
/* sample4.cpp :Lesson 4 3D Graphics */
// C~CJvZC{bNXC`悷vO
// ՓˌoC͊wvZ͂Ă܂D

#include <ode/ode.h>
#include <drawstuff/drawstuff.h>

#ifdef _MSC_VER
#pragma warning(disable:4244 4305)  // VC++px~߂
#endif

#ifdef dDOUBLE
#define dsDrawBox      dsDrawBoxD
#define dsDrawSphere   dsDrawSphereD
#define dsDrawCylinder dsDrawCylinderD
#define dsDrawCapsule  dsDrawCapsuleD
#define dsDrawLine     dsDrawLineD
#endif

#define DENSITY (5.0)	// x


struct MyObject {
  dBodyID body;		// {fBíj
};

dReal radius = 0.25; // a
dReal length = 1.0;  // 
dReal sides[3] = {0.5,0.5,1.0}; // ӂ̒

static dWorldID world;  // ͊wvZ[h
static MyObject sphere, box, capsule, cylinder; // 

// start simulation
static void start()
{
  static float xyz[3] = {5,3,0.5};    // _[m]
  static float hpr[3] = {-180, 0, 0}; // []
  dsSetViewpoint (xyz,hpr);           // _Ǝ̐ݒ
}


// V~[V[v
static void simLoop (int pause)
{
  const dReal *pos1,*R1,*pos2,*R2,*pos3,*R3;

  //@̕`
  dsSetColor(1,0,0);      // F̐ݒ (ԁC΁Cje01
  dsSetSphereQuality(3);  // ̎߂
  pos1 = dBodyGetPosition(sphere.body); // ʒu̎擾
  R1   = dBodyGetRotation(sphere.body); // p(]sj̎擾
  dsDrawSphere(pos1,R1,radius);         // ̕`

  // ~̕`
  dsSetColorAlpha (0,1,0,1);
  pos2 = dBodyGetPosition(cylinder.body);
  R2   = dBodyGetRotation(cylinder.body);
  dsDrawCylinder(pos2,R2,length,radius);  // ~̕`

  // JvZ̕`
  dsSetColorAlpha (1,1,1,1);
  pos2 = dBodyGetPosition(capsule.body);
  R2   = dBodyGetRotation(capsule.body);
  dsDrawCapsule(pos2,R2,length,radius);  // JvZ̕`

  // {bNX̕`
  dsSetColorAlpha (0,0,1,1);
  pos3 = dBodyGetPosition(box.body);
  R3   = dBodyGetRotation(box.body);
  dsDrawBox(pos3,R3,sides);             // {bNX̕`

  // ̕`
  dReal posA[3] = {0, 5, 0}, posB[3]={0, 5, 1.9};
  dsDrawLine(posA,posB); // ̕`
}

int main (int argc, char **argv)
{
  // drawstuff̐ݒ
  dsFunctions fn;
  fn.version = DS_VERSION;
  fn.start   = &start;
  fn.step    = &simLoop;
  fn.command = NULL;
  fn.stop    = NULL;
  fn.path_to_textures = "../../drawstuff/textures";


  dInitODE();              // ODȄ
  world = dWorldCreate();  // ͊wvZp[h̐

  dMass m;                 // ʃp[^
  dMassSetZero (&m);       // ʃp[^̐ݒ

  //@
  sphere.body = dBodyCreate (world);     // {fB̐
  dReal radius = 0.5;                    // a [m]
  dMassSetSphere (&m,DENSITY,radius);    // ʃp[^̌vZ
  dBodySetMass (sphere.body,&m);         // {fBɎʃp[^ݒ肷
  dBodySetPosition (sphere.body,0,1, 1); // {fB̈ʒuݒ


  //@{bNX
  box.body = dBodyCreate (world);
  dMassSetBox (&m,DENSITY,sides[0],sides[1],sides[2]);
  dBodySetMass (box.body,&m);
  dBodySetPosition (box.body,0,2,1);

  // JvZ
  capsule.body = dBodyCreate (world);
  dMassSetCapsule(&m,DENSITY,3,radius,length);
  dBodySetMass (capsule.body,&m);
  dBodySetPosition (capsule.body,0,4,1);

  // ~
  cylinder.body = dBodyCreate (world);
  dMassSetCylinder(&m,DENSITY,3,radius,length);
  dBodySetMass (cylinder.body,&m);
  dBodySetPosition (cylinder.body,0,3,1);

  // V~[V̎s
  dsSimulationLoop (argc,argv,960,480,&fn);

  dWorldDestroy (world); // [h̔j
  dCloseODE();           // ODȄI

  return 0;
}
